    local Channeled = {
        --[117952] = {'Crackling Jade Lightning',1,0,}, -- No Sound 
		[101546] = {'Spinning Crane Kick',4,0,},
		[191837] = {'Cast heal',4,0,}, -- [[ Essence Font ]]
		[115175] = {'Cast heal',4,0,}, -- [[ Soothing Mist ]]
		
    }
	
	local Cast = {
		[116670] = {'Vivify',1,0,},
		[124682] = {'Cast heal',4,0}, -- [[ Enveloping Mist ]]
		[115178] = {'Resuscitate',1,0,},
		[212051] = {'Resuscitate',1,0,}, -- [[ Reawaken ]]
	
	
	}
     
     local Instants = {
        [100784] = {'Blackout Kick',6,0,}, 
        [107428] = {'Rising Sun Kick',8,0,},
        [100780] = {'Tiger Palm',8,0,},
        --[115176] = {'Zen Meditation',1,0,}, -- No Sound
        [115078] = {'Paralysis',1,0,},
        --[115203] = {'Fortifying Brew',1,0,}, -- No Sound 
        [119381] = {'Leg Sweep',1,0,},
        --[116095] = {'Disable',1,0,}, -- No Sound
		[123986] = {'Chi Burst',1,0,},
		[122280] = {'Instant heal',8,0,}, -- [[ Healing Elixirs ]]
		--[122278] = {'Dampen Harm',1,0,}, -- No Sound
		[115546] = {'Provoke',9,0,},
		[115313] = {'Provoke',9,0,}, -- [[ Summon Jade Serpent Statue ]]
		[115008] = {'Movement',2,0,}, -- [[ Chi Torpedo ]]
		[109132] = {'Movement',2,0,}, -- [[ Roll ]]
		[116841] = {'Movement',2,0,}, -- [[ Tigers Lust ]]
		--[116844] = {'Ring of Peace',1,0,}, -- No Sound
		[119996] = {'TranscendenceTransfer',1,0,},
		[101643] = {'Transcendence',1,0,},
		[115151] = {'Instant heal',8,0,}, -- [[ Renewing Mist ]]
		[116849] = {'Life Cocoon',1,0,},
		
		--[115310] = {'Revival',1,0,}, -- No Sound 
		[116680] = {'Instant heal',8,0,}, -- [[ Thunder Focus Tea ]]
		--[197908] = {'Mana Tea',1,0,}, -- No Sound
		
		[196725] = {'Spinning Crane Kick',4,0,}, -- [[ Refreshing Jade Wind ]]
		
		
		
		
    }
	 
    
   local SoundPath = [[Interface\AddOns\JojoMonk_JosukeHigashikata\sounds\]];
   local SoundPath_Hurt = [[Interface\AddOns\JojoMonk_JosukeHigashikata\sounds\hurt\]];
   
   
   local nb_hurt_sfx = 14;
   local hurt_time = 0;
    
	
   
    local f = CreateFrame('frame');
	f:RegisterUnitEvent('UNIT_SPELLCAST_CHANNEL_START', 'player');
    f:RegisterUnitEvent('UNIT_SPELLCAST_SUCCEEDED', 'player');
	f:RegisterUnitEvent('UNIT_SPELLCAST_START','player');
	f:RegisterUnitEvent('UNIT_SPELLCAST_INTERRUPTED','player');
    f:RegisterEvent('PLAYER_DEAD');
	f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");		
	f:RegisterEvent('UNIT_COMBAT','player');
    f:SetScript('OnEvent', function(self, event, unit, _, spellID)
	
	if (JojoMonk_Config.ActiveSFX ~= true or JojoMonk_Config.ActiveCharacter ~= L['Josuke_Higashikata_drop']) then
			return false;
		end
		playerGUID = UnitGUID("player");
		self:OnPlayerSpellEvent(event,unit,_,spellID)
		self:OnCombatEvent(event,CombatLogGetCurrentEventInfo())	
		
	end)
	
    function f:OnPlayerSpellEvent(event, unit, _, spellID)
	
		if event == 'UNIT_SPELLCAST_CHANNEL_START' and Channeled[spellID] then
			if Channeled[spellID][2] ~= 1 then
				repeat
					rand_spell = math.random(1,Channeled[spellID][2]);
				until rand_spell ~= Channeled[spellID][3];
				Channeled[spellID][3] = rand_spell;
			else
				rand_spell = 1;
			end
			if(soundHandle ~= nil) then
				StopSound(soundHandle);
			end
			willPlay,soundHandle = PlaySoundFile(SoundPath .. Channeled[spellID][1] .. '_' .. rand_spell .. '.ogg', 'SFX');
		elseif event == 'UNIT_SPELLCAST_SUCCEEDED' and Instants[spellID] then
			if Instants[spellID][2] ~= 1 then
				repeat
					rand_spell = math.random(1,Instants[spellID][2]);
				until rand_spell ~= Instants[spellID][3];
				Instants[spellID][3] = rand_spell;
			else
				rand_spell = 1;
			end
			if(soundHandle ~= nil) then
				StopSound(soundHandle);
			end
			willPlay,soundHandle = PlaySoundFile(SoundPath .. Instants[spellID][1] .. '_' .. rand_spell .. '.ogg', 'SFX');
		elseif event == 'UNIT_SPELLCAST_START' and Cast[spellID] then
			if Cast[spellID][2] ~= 1 then
				repeat
					rand_spell = math.random(1,Cast[spellID][2]);
				until rand_spell ~= Cast[spellID][3];
				Cast[spellID][3] = rand_spell;
			else
				rand_spell = 1;
			end
			if(soundHandle ~= nil) then
				StopSound(soundHandle);
			end
			willPlay,soundHandle = PlaySoundFile(SoundPath .. Cast[spellID][1] .. '_' .. rand_spell .. '.ogg', 'SFX');
		elseif event == 'PLAYER_DEAD' then
			if(soundHandle ~= nil) then
				StopSound(soundHandle);
			end
			willPlay,soundHandle = PlaySoundFile(SoundPath .. 'DeadSound_' .. math.random(1,1) .. '.ogg', 'SFX');
		elseif event == 'UNIT_SPELLCAST_INTERRUPTED' then
			if(soundHandle ~= nil) then
				StopSound(soundHandle);
			end
		end
	 
	 end -- f:OnPlayerSpellEvent
	
	function f:OnCombatEvent(event,...)
		
		if(JojoMonk_Config.ActiveHurtSFX ~= true) then
			return false;
		
		end
	
		local timestamp, subevent, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...
		local spellId, spellName, spellSchool
		local amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand
		local base, stat, posBuff, negBuff = UnitStat("player",3); -- Get stamina amount
		
		if subevent == "SWING_DAMAGE" or subevent == "SPELL_DAMAGE" then
		amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing, isOffHand = select(12, ...)
		
			if destGUID == playerGUID then 
				if(hurt_time == 0 or GetTime() > hurt_time + 2) then -- 2 s delay for start the hurt sfx
					willPlay,soundHandle = PlaySoundFile(SoundPath_Hurt .. 'hurt_' .. math.random(1,nb_hurt_sfx) .. '.ogg', 'SFX');
					hurt_time = GetTime();
				end
			end
		end
	
	end -- f:OnCombatEvent
	

     
    
	
	
	
	local frame = CreateFrame("FRAME");
	frame:RegisterEvent("ADDON_LOADED"); 
	frame:RegisterEvent("PLAYER_LOGOUT");

	function frame:OnEvent(event, arg1)
		if event == "ADDON_LOADED" and arg1 == "JojoMonk_JosukeHigashikata" then
			--[[if jojo_sound == nil then
				print("Thanks for using Jojo's Monk_Josuke Higashikata addon ! Initialisation...");
				print("The addon is ready, enjoy !");
				jojo_sound = 1; ]]
			if JojoMonk_Config.ActiveCharacter == L['Josuke_Higashikata_drop'] then 
				print("Jojo's Monk_Josuke Higashikata SFX is select.");
			end
		end
	end
	frame:SetScript("OnEvent", frame.OnEvent);
	
	
	
	
	
	
	
	